## uClibc-0.9.12.tar.bz2

=== libutil/Makefile ===
# Makefile for uClibc
#
# Copyright (C) 2000 by Lineo, inc.
# Copyright (C) 2000-2002 Erik Andersen <andersen@uclibc.org>
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU Library General Public License as published by the Free
# Software Foundation; either version 2 of the License, or (at your option) any
# later version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE. See the GNU Library General Public License for more
# details.
#
# You should have received a copy of the GNU Library General Public License
# along with this program; if not, write to the Free Software Foundation, Inc.,
# 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
#
# Derived in part from the Linux-8086 C library, the GNU C Library, and several
# other sundry sources.  Files within this library are copyright by their
# respective copyright holders.

TOPDIR=../
include $(TOPDIR)Rules.mak
LIBC=$(TOPDIR)libc.a

LIBUTIL=libutil.a
LIBUTIL_SHARED=libutil.so
LIBUTIL_SHARED_FULLNAME=libutil-$(MAJOR_VERSION).$(MINOR_VERSION).$(SUBLEVEL).so

CSRC=login.c login_tty.c logout.c logwtmp.c openpty.c
ifeq ($(strip $(HAS_MMU)),true)
    CSRC+=forkpty.c
endif
OBJS=$(patsubst %.c,%.o, $(CSRC))

all: $(OBJS) $(LIBC)

$(LIBC): ar-target

ar-target: $(OBJS)
	$(AR) $(ARFLAGS) $(LIBUTIL) $(OBJS)
	install -d $(TOPDIR)lib
	rm -f $(TOPDIR)lib/$(LIBUTIL)
	install -m 644 $(LIBUTIL) $(TOPDIR)lib/

$(OBJS): %.o : %.c
	$(CC) $(CFLAGS) -c $< -o $@
	$(STRIPTOOL) -x -R .note -R .comment $*.o

shared: all
	$(LD) $(LDFLAGS) -soname=$(LIBUTIL_SHARED).$(MAJOR_VERSION) \
		-o $(LIBUTIL_SHARED_FULLNAME) --whole-archive $(LIBUTIL) \
		--no-whole-archive $(TOPDIR)/libc/misc/internals/interp.o \
		-L$(TOPDIR)/lib -lc;
	install -d $(TOPDIR)lib
	rm -f $(TOPDIR)lib/$(LIBUTIL_SHARED_FULLNAME) $(TOPDIR)lib/$(LIBUTIL_SHARED).$(MAJOR_VERSION)
	install -m 644 $(LIBUTIL_SHARED_FULLNAME) $(TOPDIR)lib/;
	(cd $(TOPDIR)lib && ln -sf $(LIBUTIL_SHARED_FULLNAME) $(LIBUTIL_SHARED)); 
	(cd $(TOPDIR)lib && ln -sf $(LIBUTIL_SHARED_FULLNAME) $(LIBUTIL_SHARED).$(MAJOR_VERSION)); 

clean:
	rm -f *.[oa] *~ core $(LIBUTIL_SHARED)* $(LIBUTIL_SHARED_FULLNAME)*

=== ldso/libdl/Makefile ===
# Makefile for uClibc
#
# Copyright (C) 2000 by Lineo, inc.
# Copyright (C) 2000-2002 Erik Andersen <andersen@uclibc.org>
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU Library General Public License as published by the Free
# Software Foundation; either version 2 of the License, or (at your option) any
# later version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE. See the GNU Library General Public License for more
# details.
#
# You should have received a copy of the GNU Library General Public License
# along with this program; if not, write to the Free Software Foundation, Inc.,
# 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
#
# Derived in part from the Linux-8086 C library, the GNU C Library, and several
# other sundry sources.  Files within this library are copyright by their
# respective copyright holders.


TOPDIR=../../
include $(TOPDIR)Rules.mak

LIBDL=libdl.a
LIBDL_SHARED=libdl.so
LIBDL_SHARED_FULLNAME=libdl-$(MAJOR_VERSION).$(MINOR_VERSION).$(SUBLEVEL).so

CSRC= dlib.c
OBJS=$(patsubst %.c,%.o, $(CSRC))

all: $(OBJS) $(LIBDL) shared

$(LIBDL): ar-target

ar-target: $(OBJS)
	$(AR) $(ARFLAGS) $(LIBDL) $(OBJS)
	#install -d $(TOPDIR)lib
	#rm -f $(TOPDIR)lib/$(LIBDL)
	#install -m 644 $(LIBDL) $(TOPDIR)lib


$(OBJS): %.o : %.c
	$(CC) -I../ldso -I../ldso/$(TARGET_ARCH) $(CFLAGS) -c $< -o $@
	$(STRIPTOOL) -x -R .note -R .comment $*.o

$(OBJ): Makefile

shared:
	$(LD) $(LDFLAGS) -soname=$(LIBDL_SHARED).$(MAJOR_VERSION) \
		-o $(LIBDL_SHARED_FULLNAME) --whole-archive $(LIBDL) \
		--no-whole-archive $(TOPDIR)/libc/misc/internals/interp.o \
		-L$(TOPDIR)/lib -lc;
	install -d $(TOPDIR)lib
	rm -f $(TOPDIR)lib/$(LIBDL_SHARED_FULLNAME) $(TOPDIR)lib/$(LIBDL_SHARED).$(MAJOR_VERSION)
	install -m 644 $(LIBDL_SHARED_FULLNAME) $(TOPDIR)lib;
	(cd $(TOPDIR)lib && ln -sf $(LIBDL_SHARED_FULLNAME) $(LIBDL_SHARED)); 
	(cd $(TOPDIR)lib && ln -sf $(LIBDL_SHARED_FULLNAME) $(LIBDL_SHARED).$(MAJOR_VERSION)); 

clean:
	$(RM) -f .depend $(LIBDL_SHARED)* $(LIBDL_SHARED_FULLNAME) core *.o *.a *.s *.i tmp_make foo *~

=== libc/inet/Makefile ===
# Makefile for uClibc
#
# Copyright (C) 2000 by Lineo, inc.
# Copyright (C) 2000,2001 Erik Andersen <andersen@uclibc.org>
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU Library General Public License as published by the Free
# Software Foundation; either version 2 of the License, or (at your option) any
# later version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE. See the GNU Library General Public License for more
# details.
#
# You should have received a copy of the GNU Library General Public License
# along with this program; if not, write to the Free Software Foundation, Inc.,
# 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
#
# Derived in part from the Linux-8086 C library, the GNU C Library, and several
# other sundry sources.  Files within this library are copyright by their
# respective copyright holders.

TOPDIR=../../
include $(TOPDIR)Rules.mak

ifeq ($(strip $(INCLUDE_RPC)),true)
	DIRS=rpc
else
	DIRS=
endif
ALL_SUBDIRS = rpc

MSRC=addr.c
MOBJ=inet_aton.o inet_addr.o inet_ntoa.o inet_makeaddr.o inet_lnaof.o \
	inet_netof.o

MSRC2=resolv.c
MOBJ2=encodeh.o decodeh.o encoded.o decoded.o lengthd.o encodeq.o \
	decodeq.o lengthq.o encodea.o decodea.o encodep.o decodep.o \
	formquery.o dnslookup.o resolveaddress.o opennameservers.o \
	closenameservers.o resolvename.o gethostbyname.o res_init.o \
	res_query.o gethostbyaddr.o read_etc_hosts_r.o get_hosts_byname_r.o \
	get_hosts_byaddr_r.o gethostbyname2.o getnameinfo.o gethostent.o \
	gethostbyname_r.o gethostbyname2_r.o gethostbyaddr_r.o

MSRC3=socketcalls.c
MOBJ3= accept.o bind.o connect.o getpeername.o getsockname.o getsockopt.o \
	listen.o recv.o recvfrom.o recvmsg.o send.o sendmsg.o sendto.o \
	setsockopt.o shutdown.o socket.o socketpair.o 

CSRC =getservice.c getproto.c hostid.c getnetent.c getnetbynm.c getnetbyad.c \
	inet_net.c ntop.c herror.c if_nametoindex.c gai_strerror.c getaddrinfo.c 

COBJS=$(patsubst %.c,%.o, $(CSRC))

OBJS=$(MOBJ) $(MOBJ2) $(MOBJ3) $(COBJS)


all: $(OBJS) $(LIBC)

$(LIBC): ar-target subdirs

ar-target: $(OBJS)
	$(AR) $(ARFLAGS) $(LIBC) $(OBJS)

$(MOBJ): $(MSRC)
	$(CC) $(CFLAGS) -DL_$* $< -c -o $*.o
	$(STRIPTOOL) -x -R .note -R .comment $*.o

$(MOBJ2): $(MSRC2)
	$(CC) $(CFLAGS) -DL_$* $< -c -o $*.o
	$(STRIPTOOL) -x -R .note -R .comment $*.o

$(MOBJ3): $(MSRC3)
	$(CC) $(CFLAGS) -DL_$* $< -c -o $*.o
	$(STRIPTOOL) -x -R .note -R .comment $*.o

$(COBJS): %.o : %.c
	$(CC) $(CFLAGS) -c $< -o $@
	$(STRIPTOOL) -x -R .note -R .comment $*.o

clean: subdirs_clean
	rm -f *.[oa] *~ core

subdirs: $(patsubst %, _dir_%, $(DIRS))
subdirs_clean: $(patsubst %, _dirclean_%, $(ALL_SUBDIRS))

$(patsubst %, _dir_%, $(DIRS)) : dummy
	$(MAKE) -C $(patsubst _dir_%, %, $@)

$(patsubst %, _dirclean_%, $(ALL_SUBDIRS)) : dummy
	$(MAKE) -C $(patsubst _dirclean_%, %, $@) clean

.PHONY: dummy

=== libc/stdio/Makefile ===
# Makefile for uClibc
#
# Copyright (C) 2000 by Lineo, inc.
# Copyright (C) 2000,2001 Erik Andersen <andersen@uclibc.org>
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU Library General Public License as published by the Free
# Software Foundation; either version 2 of the License, or (at your option) any
# later version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE. See the GNU Library General Public License for more
# details.
#
# You should have received a copy of the GNU Library General Public License
# along with this program; if not, write to the Free Software Foundation, Inc.,
# 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
#
# Derived in part from the Linux-8086 C library, the GNU C Library, and several
# other sundry sources.  Files within this library are copyright by their
# respective copyright holders.

TOPDIR=../../
include $(TOPDIR)Rules.mak

# Set to true to use the old vfprintf instead of the new.  The old is roughly
# C89 compliant, but doesn't deal with qualifiers on %n and doesn't deal with
# %h correctly or %hh at all on the interger conversions.  But on i386 it is
# over 1.5k smaller than the new code.  Of course, the new code fixes the
# above mentioned deficiencies and adds custom specifier support similar to
# glibc, as well as handling positional args.  This option is here temporarily
# until the configuration system gets rewritten.  Note also that the old
# vfprintf code will be rewritten at some point to bring it into at least C89
# standards compliance.

USE_OLD_VFPRINTF = false

# Note: The *64.o objects are empty when compiled without large file support.
#       To not build them at all, remove the appropriate line from the MOBJ
#       definition and uncomment the DOLFS test below.

# Note: Use the libpthreads of: flockfile.o ftrylockfile.o funlockfile.o
#       Also, maybe move __fsetlocking.o as well?

MSRC = stdio.c
MOBJ = fclose.o fflush.o fopen.o freopen.o perror.o remove.o \
	setbuf.o setvbuf.o fgetc.o fgets.o fputc.o fputs.o \
	getc.o getchar.o gets.o putc.o putchar.o puts.o \
	ungetc.o fread.o fwrite.o fgetpos.o fseek.o fsetpos.o ftell.o \
	rewind.o clearerr.o feof.o ferror.o \
	fileno.o fdopen.o getw.o putw.o setbuffer.o setlinebuf.o fcloseall.o \
	fopen64.o freopen64.o ftello64.o fseeko64.o fsetpos64.o fgetpos64.o \
	__fbufsize.o __freading.o __fwriting.o __freadable.o __fwritable.o \
	__flbf.o __fpurge.o __fpending.o _flushlbf.o \
	 fopencookie.o fmemopen.o open_memstream.o \
	__fsetlocking.o flockfile.o ftrylockfile.o funlockfile.o \
	_stdio_fopen.o _stdio_fread.o _stdio_fwrite.o _stdio_adjpos.o \
	_stdio_lseek.o _stdio_init.o \
	_stdio_fsfopen.o _stdio_fdout.o _uintmaxtostr.o _stdio_strerror_r.o

# ifeq ($(DOLFS),true)
# 	MOBJ += fopen64.o freopen64.o ftello64.o fseeko64.o fsetpos64.o fgetpos64.o
# endif

MSRC2= printf.c
MOBJ2=  vsnprintf.o vdprintf.o vasprintf.o vprintf.o vsprintf.o \
	fprintf.o  snprintf.o  dprintf.o  asprintf.o  printf.o  sprintf.o

ifneq ($(USE_OLD_VFPRINTF),true)
	MOBJ2 += _ppfs_init.o _ppfs_prepargs.o _ppfs_setargs.o \
		 _ppfs_parsespec.o _do_one_spec.o vfprintf.o \
		 _store_inttype.o _load_inttype.o \
		 register_printf_function.o parse_printf_format.o
endif



ifeq ($(HAS_FLOATING_POINT),true)
	MOBJ2 += _dtostr.o
endif

MSRC3=scanf.c
MOBJ3=scanf.o sscanf.o fscanf.o vscanf.o vsscanf.o vfscanf.o

CSRC=popen.c getdelim.c getline.c tmpfile.c tmpnam.c \
     tmpnam_r.c tempnam.c ctermid.c
ifeq ($(USE_OLD_VFPRINTF),true)
	CSRC += old_vfprintf.c
endif
COBJS=$(patsubst %.c,%.o, $(CSRC))

OBJS=$(MOBJ) $(MOBJ2) $(MOBJ3) $(COBJS)

all: $(OBJS) $(LIBC)

$(LIBC): ar-target

ar-target: $(OBJS)
	$(AR) $(ARFLAGS) $(LIBC) $(OBJS)

$(MOBJ): $(MSRC)
	$(CC) $(CFLAGS) -DL_$* $< -c -o $*.o
	$(STRIPTOOL) -x -R .note -R .comment $*.o

$(MOBJ2): $(MSRC2)
	$(CC) $(CFLAGS) -DL_$* $< -c -o $*.o
	$(STRIPTOOL) -x -R .note -R .comment $*.o

$(MOBJ3): $(MSRC3)
	$(CC) $(CFLAGS) -DL_$* $< -c -o $*.o
	$(STRIPTOOL) -x -R .note -R .comment $*.o

$(COBJS): %.o : %.c
	$(CC) $(CFLAGS) -c $< -o $@
	$(STRIPTOOL) -x -R .note -R .comment $*.o

$(OBJ): Makefile

clean:
	rm -f *.[oa] *~ core

=== libpthread/linuxthreads/Makefile ===
# Makefile for uClibc's pthread library
#
# Copyright (C) 2002 Erik Andersen <andersen@uclibc.org>
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU Library General Public License as published by the Free
# Software Foundation; either version 2 of the License, or (at your option) any
# later version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE. See the GNU Library General Public License for more
# details.
#
# You should have received a copy of the GNU Library General Public License
# along with this program; if not, write to the Free Software Foundation, Inc.,
# 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
# Makefile for uClibc

TOPDIR=../../
include $(TOPDIR)Rules.mak

#Adjust the soname version to avoid namespace collisions with glibc's libpthread
LIBPTHREAD:=../libpthread.a
ifeq ($(strip $(TARGET_ARCH)),sparc)
SYSDEPS_DIR:=$(TARGET_ARCH)/sparc32
else
SYSDEPS_DIR:=$(TARGET_ARCH)
endif

# set up system dependencies include dirs (NOTE: order matters!)
PTDIR = $(TOPDIR)libpthread/linuxthreads/
SYSDEPINC = -I$(PTDIR)sysdeps/unix/sysv/linux \
            -I$(PTDIR)sysdeps/pthread \
            -I$(PTDIR)sysdeps/unix/sysv \
            -I$(PTDIR)sysdeps/unix/unix \
            -I$(PTDIR)sysdeps/$(TARGET_ARCH) \
            -I$(PTDIR)sysdeps \
            -I$(TOPDIR)libc/sysdeps/linux/$(TARGET_ARCH)
CFLAGS += $(SYSDEPINC) -DLIBPTHREAD_SO="\"libpthread.so.$(MAJOR_VERSION)\""

CSRC=attr.c cancel.c condvar.c errno.c events.c join.c lockfile.c manager.c \
	mutex.c oldsemaphore.c pt-machine.c ptfork.c pthread.c \
	ptlongjmp.c rwlock.c semaphore.c signals.c specific.c spinlock.c \
	wrapsyscall.c #weaks.c no-tsd.c
COBJS=$(patsubst %.c,%.o, $(CSRC))
OBJS=$(COBJS)

all: $(OBJS) $(LIBPTHREAD)

$(LIBPTHREAD): ar-target

ar-target: $(OBJS)
	$(AR) $(ARFLAGS) $(LIBPTHREAD) $(OBJS)

$(COBJS): %.o : %.c
	$(CC) $(CFLAGS) -c $< -o $@
	$(STRIPTOOL) -x -R .note -R .comment $*.o

clean:
	rm -f *.[oa] *~ core

=== libpthread/linuxthreads_db/Makefile ===
# Makefile for uClibc's pthread library
#
# Copyright (C) 2002 Erik Andersen <andersen@uclibc.org>
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU Library General Public License as published by the Free
# Software Foundation; either version 2 of the License, or (at your option) any
# later version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE. See the GNU Library General Public License for more
# details.
#
# You should have received a copy of the GNU Library General Public License
# along with this program; if not, write to the Free Software Foundation, Inc.,
# 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
# Makefile for uClibc

TOPDIR=../../
include $(TOPDIR)Rules.mak

#Adjust the soname version to avoid namespace collisions with glibc's libpthread
PT_VERSION=$(MAJOR_VERSION).$(MINOR_VERSION).$(SUBLEVEL)
LIBPTHREAD=../libpthread.a

# set up system dependencies include dirs (NOTE: order matters!)
PTDIR = $(TOPDIR)libpthread/linuxthreads/
SYSDEPINC = -I$(PTDIR)sysdeps/unix/sysv/linux \
            -I$(PTDIR)sysdeps/pthread \
            -I$(PTDIR)sysdeps/unix/sysv \
            -I$(PTDIR)sysdeps/unix/unix \
            -I$(PTDIR)sysdeps/$(TARGET_ARCH) \
            -I$(PTDIR)sysdeps \
            -I$(TOPDIR)libc/sysdeps/linux/$(TARGET_ARCH)
CFLAGS += $(SYSDEPINC) -DLIBPTHREAD_SO="\"libpthread.so.$(PT_VERSION)\""

CSRC=td_init.c td_log.c td_ta_clear_event.c td_ta_delete.c \
	td_ta_enable_stats.c td_ta_event_addr.c td_ta_event_getmsg.c \
	td_ta_get_nthreads.c td_ta_get_ph.c td_ta_get_stats.c \
	td_ta_map_id2thr.c td_ta_map_lwp2thr.c td_ta_new.c td_ta_reset_stats.c \
	td_ta_set_event.c td_ta_setconcurrency.c td_ta_thr_iter.c \
	td_ta_tsd_iter.c td_thr_clear_event.c td_thr_dbresume.c \
	td_thr_dbsuspend.c td_thr_event_enable.c td_thr_event_getmsg.c \
	td_thr_get_info.c td_thr_getfpregs.c td_thr_getgregs.c \
	td_thr_getxregs.c td_thr_getxregsize.c td_thr_set_event.c \
	td_thr_setfpregs.c td_thr_setgregs.c td_thr_setprio.c \
	td_thr_setsigpending.c td_thr_setxregs.c td_thr_sigsetmask.c \
	td_thr_tsd.c td_thr_validate.c
COBJS=$(patsubst %.c,%.o, $(CSRC))
OBJS=$(COBJS)

all: $(OBJS) $(LIBPTHREAD)

$(LIBPTHREAD): ar-target

ar-target: $(OBJS)
	$(AR) $(ARFLAGS) $(LIBPTHREAD) $(OBJS)

$(COBJS): %.o : %.c
	$(CC) $(CFLAGS) -c $< -o $@
	$(STRIPTOOL) -x -R .note -R .comment $*.o

clean:
	rm -f *.[oa] *~ core

=== test/ldso/Makefile ===
# Makefile for uClibc
#
# Copyright (C) 2000,2001 Erik Andersen <andersen@uclibc.org>
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU Library General Public License as published by the Free
# Software Foundation; either version 2 of the License, or (at your option) any
# later version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE. See the GNU Library General Public License for more
# details.
#
# You should have received a copy of the GNU Library General Public License
# along with this program; if not, write to the Free Software Foundation, Inc.,
# 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

TESTDIR=../
include $(TESTDIR)/Rules.mak

all: dltest libhowdy.so run

dltest.o: dltest.c
	$(CC) $(CFLAGS) -c dltest.c -o dltest.o

howdy.o: howdy.c
	$(CC) $(CFLAGS) -fPIC -c howdy.c -o howdy.o

libhowdy.so: howdy.o
	$(CC) $(CFLAGS) -shared -o libhowdy.so -Wl,-soname,libhowdy.so howdy.o

dltest: dltest.o
	$(CC) $(CFLAGS) -o dltest dltest.o -ldl
	
run: dltest libhowdy.so
	@echo Running dltest
	./dltest

clean:
	rm -f *.o *.so dltest core libhowdy.so

=== test/stdlib/Makefile ===
# Makefile for uClibc
#
# Copyright (C) 2000,2001 Erik Andersen <andersen@uclibc.org>
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU Library General Public License as published by the Free
# Software Foundation; either version 2 of the License, or (at your option) any
# later version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE. See the GNU Library General Public License for more
# details.
#
# You should have received a copy of the GNU Library General Public License
# along with this program; if not, write to the Free Software Foundation, Inc.,
# 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

TESTDIR=../
include $(TESTDIR)/Rules.mak



TARGETS=testmalloc testmalloc_glibc 
TARGETS+=mallocbug mallocbug_glibc
TARGETS+=teststrtol teststrtol_glibc teststrtol_diff
TARGETS+=qsort qsort_glibc qsort_diff
TARGETS+=teston_exit teston_exit_glibc teston_exit_diff
TARGETS+=testatexit testatexit_glibc testatexit_diff

all: $(TARGETS)

testmalloc_source:
	-@ echo "-------"
	-@ echo "testmalloc.c source: "
	-@ echo " "
	-@ cat testmalloc.c
	-@ echo " "

testmalloc: testmalloc.c Makefile $(TESTDIR)/Config $(TESTDIR)/Rules.mak $(CC)
	-@ echo "-------"
	-@ echo " "
	-@ echo "Compiling vs uClibc: "
	-@ echo " "
	$(CC) $(CFLAGS) -c $< -o $@.o
	$(CC) $(LDFLAGS) $@.o -o $@ $(EXTRA_LIBS)
	$(STRIPTOOL) -x -R .note -R .comment $@
	-$(LDD) $@
	ls -l $@
	-./$@
	-@ echo " "

testmalloc_glibc: testmalloc.c Makefile
	-@ echo "-------"
	-@ echo " "
	-@ echo "Compiling vs GNU libc: "
	-@ echo " "
	$(HOST_CC) $(GLIBC_CFLAGS) -c $< -o $@.o
	$(HOST_CC) $(GLIBC_LDFLAGS) $@.o -o $@
	$(STRIPTOOL) -x -R .note -R .comment $@
	-$(LDD) $@
	ls -l $@
	-./$@
	-@ echo " "

mallocbug: mallocbug.c Makefile $(TESTDIR)/Config $(TESTDIR)/Rules.mak $(CC)
	-@ echo "-------"
	-@ echo " "
	-@ echo "Compiling vs uClibc: "
	-@ echo " "
	$(CC) $(CFLAGS) -c $< -o $@.o
	$(CC) $(LDFLAGS) $@.o -o $@ $(EXTRA_LIBS)
	$(STRIPTOOL) -x -R .note -R .comment $@
	-$(LDD) $@
	ls -l $@
	-./$@
	-@ echo " "

mallocbug_glibc: mallocbug.c Makefile
	-@ echo "-------"
	-@ echo " "
	-@ echo "Compiling vs GNU libc: "
	-@ echo " "
	$(HOST_CC) $(GLIBC_CFLAGS) -c $< -o $@.o
	$(HOST_CC) $(GLIBC_LDFLAGS) $@.o -o $@
	$(STRIPTOOL) -x -R .note -R .comment $@
	-$(LDD) $@
	ls -l $@
	-./$@
	-@ echo " "

teststrtol_source:
	-@ echo "-------"
	-@ echo "teststrtol.c source: "
	-@ echo " "
	-@ cat teststrtol.c
	-@ echo " "

teststrtol: teststrtol.c Makefile $(TESTDIR)/Config $(TESTDIR)/Rules.mak $(CC)
	-@ echo "-------"
	-@ echo " "
	-@ echo "Compiling vs uClibc: "
	-@ echo " "
	$(CC) $(CFLAGS) -c $< -o $@.o
	$(CC) $(LDFLAGS) $@.o -o $@ $(EXTRA_LIBS)
	$(STRIPTOOL) -x -R .note -R .comment $@
	-$(LDD) $@
	ls -l $@
	-./$@ > $@.out
	-@ echo " "

teststrtol_glibc: teststrtol.c Makefile
	-@ echo "-------"
	-@ echo " "
	-@ echo "Compiling vs GNU libc: "
	-@ echo " "
	$(HOST_CC) $(GLIBC_CFLAGS) -c $< -o $@.o
	$(HOST_CC) $(GLIBC_LDFLAGS) $@.o -o $@
	$(STRIPTOOL) -x -R .note -R .comment $@
	-$(LDD) $@
	ls -l $@
	-./$@ > $@.out
	-@ echo " "

teststrtol_diff: teststrtol_glibc teststrtol
	-@ echo "-------"
	-@ echo " "
	-@ echo "Diffing output: "
	-@ echo " "
	-diff -u teststrtol_glibc.out teststrtol.out
	-@ echo " "

qsort: qsort.c Makefile $(TESTDIR)/Config $(TESTDIR)/Rules.mak $(CC)
	-@ echo "-------"
	-@ echo " "
	-@ echo "Compiling vs uClibc: "
	-@ echo " "
	$(CC) $(CFLAGS) -c $< -o $@.o
	$(CC) $(LDFLAGS) $@.o -o $@ $(EXTRA_LIBS)
	$(STRIPTOOL) -x -R .note -R .comment $@
	-$(LDD) $@
	ls -l $@
	-./$@ > $@.out
	-@ echo " "

qsort_glibc: qsort.c Makefile
	-@ echo "-------"
	-@ echo " "
	-@ echo "Compiling vs GNU libc: "
	-@ echo " "
	$(HOST_CC) $(GLIBC_CFLAGS) -c $< -o $@.o
	$(HOST_CC) $(GLIBC_LDFLAGS) $@.o -o $@
	$(STRIPTOOL) -x -R .note -R .comment $@
	-$(LDD) $@
	ls -l $@
	-./$@ > $@.out
	-@ echo " "

qsort_diff: qsort_glibc qsort
	-@ echo "-------"
	-@ echo " "
	-@ echo "Diffing output: "
	-@ echo " "
	-diff -u qsort_glibc.out qsort.out
	-@ echo " "

teston_exit: teston_exit.c Makefile $(TESTDIR)/Config $(TESTDIR)/Rules.mak $(CC)
	-@ echo "-------"
	-@ echo " "
	-@ echo "Compiling vs uClibc: "
	-@ echo " "
	$(CC) $(CFLAGS) -c $< -o $@.o
	$(CC) $(LDFLAGS) $@.o -o $@ $(EXTRA_LIBS)
	$(STRIPTOOL) -x -R .note -R .comment $@
	-$(LDD) $@
	ls -l $@
	-./$@ > $@.out
	-@ echo " "

teston_exit_glibc: teston_exit.c Makefile
	-@ echo "-------"
	-@ echo " "
	-@ echo "Compiling vs GNU libc: "
	-@ echo " "
	$(HOST_CC) $(GLIBC_CFLAGS) -c $< -o $@.o
	$(HOST_CC) $(GLIBC_LDFLAGS) $@.o -o $@
	$(STRIPTOOL) -x -R .note -R .comment $@
	-$(LDD) $@
	ls -l $@
	-./$@ > $@.out
	-@ echo " "

teston_exit_diff: teston_exit_glibc teston_exit
	-@ echo "-------"
	-@ echo " "
	-@ echo "Diffing output: "
	-@ echo " "
	-diff -u teston_exit_glibc.out teston_exit.out
	-@ echo " "

testatexit: testatexit.c Makefile $(TESTDIR)/Config $(TESTDIR)/Rules.mak $(CC)
	-@ echo "-------"
	-@ echo " "
	-@ echo "Compiling vs uClibc: "
	-@ echo " "
	$(CC) $(CFLAGS) -c $< -o $@.o
	$(CC) $(LDFLAGS) $@.o -o $@ $(EXTRA_LIBS)
	$(STRIPTOOL) -x -R .note -R .comment $@
	-$(LDD) $@
	ls -l $@
	-./$@ > $@.out
	-@ echo " "

testatexit_glibc: testatexit.c Makefile
	-@ echo "-------"
	-@ echo " "
	-@ echo "Compiling vs GNU libc: "
	-@ echo " "
	$(HOST_CC) $(GLIBC_CFLAGS) -c $< -o $@.o
	$(HOST_CC) $(GLIBC_LDFLAGS) $@.o -o $@
	$(STRIPTOOL) -x -R .note -R .comment $@
	-$(LDD) $@
	ls -l $@
	-./$@ > $@.out
	-@ echo " "

testatexit_diff: testatexit_glibc testatexit
	-@ echo "-------"
	-@ echo " "
	-@ echo "Diffing output: "
	-@ echo " "
	-diff -u testatexit_glibc.out testatexit.out
	-@ echo " "


clean:
	rm -f *.[oa] *~ core $(TARGETS) *.out

=== libc/stdlib/malloc-930716/Makefile ===
# Makefile for uClibc
#
# Copyright (C) 2000 by Lineo, inc.
# Copyright (C) 2000,2001 Erik Andersen <andersen@uclibc.org>
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU Library General Public License as published by the Free
# Software Foundation; either version 2 of the License, or (at your option) any
# later version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE. See the GNU Library General Public License for more
# details.
#
# You should have received a copy of the GNU Library General Public License
# along with this program; if not, write to the Free Software Foundation, Inc.,
# 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
#
# Derived in part from the Linux-8086 C library, the GNU C Library, and several
# other sundry sources.  Files within this library are copyright by their
# respective copyright holders.

TOPDIR=../../../
include $(TOPDIR)Rules.mak

CSRC=calloc.c malloc.c
COBJS=$(patsubst %.c,%.o, $(CSRC))

MSRC=../malloc/alloc.c
MOBJ=#malloc_dbg.o free_dbg.o calloc_dbg.o
OBJS=$(COBJS) $(MOBJ)

all: $(OBJS) $(LIBC)

$(LIBC): ar-target

ar-target: $(OBJS)
	$(AR) $(ARFLAGS) $(LIBC) $(OBJS)

$(MOBJ): $(MSRC)
	$(CC) $(CFLAGS) -DL_$* $< -c -o $*.o
	$(STRIPTOOL) -x -R .note -R .comment $*.o

$(COBJS): %.o : %.c
	$(CC) $(CFLAGS) -c $< -o $@
	$(STRIPTOOL) -x -R .note -R .comment $*.o

clean:
	rm -f *.[oa] *~ core

=== libc/sysdeps/linux/Makefile ===
# Makefile for uClibc
#
# Copyright (C) 2000 by Lineo, inc.
# Copyright (C) 2000,2001 Erik Andersen <andersen@uclibc.org>
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU Library General Public License as published by the Free
# Software Foundation; either version 2 of the License, or (at your option) any
# later version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE. See the GNU Library General Public License for more
# details.
#
# You should have received a copy of the GNU Library General Public License
# along with this program; if not, write to the Free Software Foundation, Inc.,
# 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
#
# Derived in part from the Linux-8086 C library, the GNU C Library, and several
# other sundry sources.  Files within this library are copyright by their
# respective copyright holders.

TOPDIR=../../../
include $(TOPDIR)Rules.mak

DIRS = common $(TARGET_ARCH)
ALL_SUBDIRS = arm common h8300 i386 m68k mips powerpc sh sparc v850

all: subdirs

tags:
	ctags -R

clean: subdirs_clean

subdirs: $(patsubst %, _dir_%, $(DIRS))
subdirs_clean: $(patsubst %, _dirclean_%, $(ALL_SUBDIRS))

$(patsubst %, _dir_%, $(DIRS)) : dummy
	$(MAKE) -C $(patsubst _dir_%, %, $@)

$(patsubst %, _dirclean_%, $(ALL_SUBDIRS)) : dummy
	$(MAKE) -C $(patsubst _dirclean_%, %, $@) clean


.PHONY: dummy

=== libc/sysdeps/linux/alpha/Makefile ===
# Makefile for uClibc
#
# Copyright (C) 2002 Erik Andersen <andersen@uclibc.org>
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU Library General Public License as published by the Free
# Software Foundation; either version 2 of the License, or (at your option) any
# later version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE. See the GNU Library General Public License for more
# details.
#
# You should have received a copy of the GNU Library General Public License
# along with this program; if not, write to the Free Software Foundation, Inc.,
# 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
#
# Derived in part from the Linux-8086 C library, the GNU C Library, and several
# other sundry sources.  Files within this library are copyright by their
# respective copyright holders.

TOPDIR=../../../../
include $(TOPDIR)Rules.mak
ASFLAGS=$(CFLAGS)

CRT0=crt0.S
CRT0_OBJ=$(patsubst %.S,%.o, $(CRT0))


SSRC=__longjmp.S brk.S bsd-_setjmp.S bsd-setjmp.S clone.S \
    setjmp.S divl.S reml.S remq.S divq.S 
SOBJS=$(patsubst %.S,%.o, $(SSRC))

CSRC=sysdep.c #brk.c
COBJS=$(patsubst %.c,%.o, $(CSRC))

OBJS=$(SOBJS) $(COBJS)


all: $(OBJS) $(LIBC)

$(LIBC): ar-target 

ar-target: $(OBJS) $(CRT0_OBJ)
	$(AR) $(ARFLAGS) $(LIBC) $(OBJS)
	cp $(CRT0_OBJ) $(TOPDIR)lib/$(CRT0_OBJ)

$(CRT0_OBJ): %.o : %.S
	$(CC) $(CFLAGS) -c $< -o $@
	$(STRIPTOOL) -x -R .note -R .comment $*.o

$(SOBJS): %.o : %.S
	$(CC) $(CFLAGS) -c $< -o $@
	$(STRIPTOOL) -x -R .note -R .comment $*.o

$(COBJS): %.o : %.c
	$(CC) $(CFLAGS) -c $< -o $@
	$(STRIPTOOL) -x -R .note -R .comment $*.o

headers:


clean:
	rm -f *.[oa] *~ core
	rm -f bits/syscall.h

=== libc/sysdeps/linux/common/Makefile ===
# Makefile for uClibc
#
# Copyright (C) 2000 by Lineo, inc.
# Copyright (C) 2000,2001 Erik Andersen <andersen@uclibc.org>
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU Library General Public License as published by the Free
# Software Foundation; either version 2 of the License, or (at your option) any
# later version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE. See the GNU Library General Public License for more
# details.
#
# You should have received a copy of the GNU Library General Public License
# along with this program; if not, write to the Free Software Foundation, Inc.,
# 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
#
# Derived in part from the Linux-8086 C library, the GNU C Library, and several
# other sundry sources.  Files within this library are copyright by their
# respective copyright holders.

TOPDIR=../../../../
include $(TOPDIR)Rules.mak

SAFECFLAGS=$(WARNINGS) $(OPTIMIZATION) -fno-builtin
ifeq ($(strip $(DOPIC)),true)
SAFECFLAGS+=-fPIC
endif

CSRC=	waitpid.c statfix.c getdnnm.c gethstnm.c getcwd.c \
	mkfifo.c setegid.c wait.c getpagesize.c seteuid.c \
	wait3.c setpgrp.c getdtablesize.c create_module.c ptrace.c \
	cmsg_nxthdr.c statfix64.c longjmp.c open64.c ftruncate64.c \
	truncate64.c getrlimit64.c setrlimit64.c creat64.c mmap64.c
ifneq ($(strip $(EXCLUDE_BRK)),true)
CSRC+=sbrk.c
endif
COBJS=$(patsubst %.c,%.o, $(CSRC))

MSRC=syscalls.c
MOBJ=$(shell ./list_syscalls.sh)

OBJ=$(COBJS) $(MOBJ)

all: $(STR_SYSCALLS) $(OBJ) $(LIBC)

$(LIBC): ar-target

ar-target: $(OBJ) $(TOPDIR)lib/crti.o $(TOPDIR)lib/crtn.o
	$(AR) $(ARFLAGS) $(LIBC) $(OBJ)

$(MOBJ): $(MSRC)
	$(CC) $(CFLAGS) -DL_$* $< -c -o $*.o
	$(STRIPTOOL) -x -R .note -R .comment $*.o

$(COBJS): %.o : %.c
	$(CC) $(CFLAGS) -c $< -o $@
	$(STRIPTOOL) -x -R .note -R .comment $*.o

initfini.s: initfini.c
	$(CC) $(SAFECFLAGS) -c initfini.c -S -o initfini.s

crti.S crtn.S: initfini.s
	$(TOPDIR)/extra/scripts/initfini.pl

crti.o: crti.S
	$(CC) $(SAFECFLAGS) -c crti.S -o crti.o

$(TOPDIR)lib/crti.o: crti.o
	mkdir -p $(TOPDIR)lib/
	cp crti.o $(TOPDIR)lib/

crtn.o: crtn.S
	$(CC) $(SAFECFLAGS) -c crtn.S -o crtn.o

$(TOPDIR)lib/crtn.o: crtn.o
	mkdir -p $(TOPDIR)lib/
	cp crtn.o $(TOPDIR)lib/

clean:
	rm -f *.[oa] *~ core crti.* crtn.* initfini.s

=== debian/control ===
Source: uclibc
Section: devel
Priority: optional
Maintainer: David Schleef <ds@schleef.org>
Build-Depends: debhelper, bzip2, kernel-source-2.4.18
Standards-Version: 3.5.6

Package: libuclibc-dev
Section: devel
Architecture: arm i386 m68k mips mipsel powerpc sh sparc
Depends: libuclibc0 (= ${Source-Version})
Description: A small implementation of the C library
 uClibc is an implementation of the standard C library that is
 much smaller than glibc, which makes it useful for embedded
 systems.  This package includes header files and development
 libraries necessary to compile applications that use uClibc.

Package: libuclibc0
Section: libs
Architecture: arm i386 m68k mips mipsel powerpc sh sparc
Depends:
Description: A small implementation of the C library
 uClibc is an implementation of the standard C library that is
 much smaller than glibc, which makes it useful for embedded
 systems.  This package provides only the run-time libraries.
 .
 The Debian binary packages for uClibc do not provide the necessary
 components for using uClibc as the primary library on a system,
 as might be done for an embedded system.

Package: uclibc-toolchain
Section: devel
Architecture: arm i386 m68k mips mipsel powerpc sh sparc
Depends: gcc|c-compiler, binutils, ${shlibs:Depends}
Recommends: libuclibc-dev
Conflicts: uclibc-gcc
Replaces: uclibc-gcc
Description: A compiler wrapper for uClibc
 This package includes utilities that function as a toolchain for
 compiling with uClibc instead of the native libc.  The utilities
 have names such as powerpc-uclibc-gcc (depending on the architecture),
 and should behave identically to the base utilities, except that
 they use headers and libraries provided in the libuclibc-dev
 package.  Most utilities are symbolic links to the correct underlying
 utility, although gcc and ld are implemented as wrapper binaries that
 call gcc and ld with the necessary arguments and command line options.
